org.apache.xalan.xsltc.trax

## Class SAX2DOM

- java.lang.Object
- - org.apache.xalan.xsltc.trax.SAX2DOM

- All Implemented Interfaces:
    Constants, ContentHandler, LexicalHandler

      public class SAX2DOM
      extends java.lang.Object
      implements ContentHandler, LexicalHandler, Constants

  Author:
    G. Todd Miller

- - ### Field Summary

    - ### Fields inherited from interface org.apache.xalan.xsltc.runtime.Constants

      `ANY, ATTRIBUTE, COMMENT, ELEMENT, EMPTYSTRING, NAMESPACE_FEATURE, PROCESSING_INSTRUCTION, ROOT, TEXT, XML_PREFIX, XMLNS_PREFIX, XMLNS_STRING, XMLNS_URI, XSLT_URI`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SAX2DOM()`
    `SAX2DOM(Node root)`
    `SAX2DOM(Node root, Node nextSibling)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `characters(char[] ch, int start, int length)` Receive notification of character data.
    `void` | `comment(char[] ch, int start, int length)` Lexical Handler method to create comment node in DOM tree.
    `void` | `endCDATA()` Report the end of a CDATA section.
    `void` | `endDocument()` Receive notification of the end of a document.
    `void` | `endDTD()` Report the end of DTD declarations.
    `void` | `endElement(java.lang.String namespace, java.lang.String localName, java.lang.String qName)` Receive notification of the end of an element.
    `void` | `endEntity(java.lang.String name)` Report the end of an entity.
    `void` | `endPrefixMapping(java.lang.String prefix)` End the scope of a prefix-URI mapping.
    `Node` | `getDOM()`
    `void` | `ignorableWhitespace(char[] ch, int start, int length)` This class is only used internally so this method should never be called.
    `void` | `processingInstruction(java.lang.String target, java.lang.String data)` adds processing instruction node to DOM.
    `void` | `setDocumentLocator(Locator locator)` This class is only used internally so this method should never be called.
    `void` | `skippedEntity(java.lang.String name)` This class is only used internally so this method should never be called.
    `void` | `startCDATA()` Report the start of a CDATA section.
    `void` | `startDocument()` Receive notification of the beginning of a document.
    `void` | `startDTD(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Report the start of DTD declarations, if any.
    `void` | `startElement(java.lang.String namespace, java.lang.String localName, java.lang.String qName, Attributes attrs)` Receive notification of the beginning of an element.
    `void` | `startEntity(java.lang.String name)` Report the beginning of some internal and external XML entities.
    `void` | `startPrefixMapping(java.lang.String prefix, java.lang.String uri)` Begin the scope of a prefix-URI Namespace mapping.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SAX2DOM

          public SAX2DOM()
                  throws ParserConfigurationException

      Throws:
        `ParserConfigurationException`

    - #### SAX2DOM

          public SAX2DOM(Node root,
                 Node nextSibling)
                  throws ParserConfigurationException

      Throws:
        `ParserConfigurationException`

    - #### SAX2DOM

          public SAX2DOM(Node root)
                  throws ParserConfigurationException

      Throws:
        `ParserConfigurationException`

  - ### Method Detail

    - #### getDOM

          public Node getDOM()

    - #### characters

          public void characters(char[] ch,
                        int start,
                        int length)

      Description copied from interface: `ContentHandler`
      Receive notification of character data.

      The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity so that the Locator provides useful information.

      The application must not attempt to read from the array outside of the specified range.

      Individual characters may consist of more than one Java `char` value. There are two important cases where this happens, because characters can't be represented in just sixteen bits. In one case, characters are represented in a Surrogate Pair, using two special Unicode values. Such characters are in the so-called "Astral Planes", with a code point above U+FFFF. A second case involves composite characters, such as a base character combining with one or more accent characters.

      Your code should not assume that algorithms using `char`-at-a-time idioms will be working in character units; in some cases they will split characters. This is relevant wherever XML permits arbitrary characters, such as attribute values, processing instruction data, and comments as well as in data reported from this method. It's also generally relevant whenever Java code manipulates internationalized text; the issue isn't unique to XML.

      Note that some parsers will report whitespace in element content using the `ignorableWhitespace` method rather than this one (validating parsers must do so).

      Specified by:
        `characters` in interface `ContentHandler`
      Parameters:
        `ch` - the characters from the XML document
        `start` - the start position in the array
        `length` - the number of characters to read from the array
      See Also:
        `ContentHandler.ignorableWhitespace(char[], int, int)`, `Locator`

    - #### startDocument

          public void startDocument()

      Description copied from interface: `ContentHandler`
      Receive notification of the beginning of a document.

      The SAX parser will invoke this method only once, before any other event callbacks (except for `setDocumentLocator`).

      Specified by:
        `startDocument` in interface `ContentHandler`
      See Also:
        `ContentHandler.endDocument()`

    - #### endDocument

          public void endDocument()

      Description copied from interface: `ContentHandler`
      Receive notification of the end of a document.

      There is an apparent contradiction between the documentation for this method and the documentation for `ErrorHandler.fatalError(org.xml.sax.SAXParseException)`. Until this ambiguity is resolved in a future major release, clients should make no assumptions about whether endDocument() will or will not be invoked when the parser has reported a fatalError() or thrown an exception.

      The SAX parser will invoke this method only once, and it will be the last method invoked during the parse. The parser shall not invoke this method until it has either abandoned parsing (because of an unrecoverable error) or reached the end of input.

      Specified by:
        `endDocument` in interface `ContentHandler`
      See Also:
        `ContentHandler.startDocument()`

    - #### startElement

          public void startElement(java.lang.String namespace,
                          java.lang.String localName,
                          java.lang.String qName,
                          Attributes attrs)

      Description copied from interface: `ContentHandler`
      Receive notification of the beginning of an element.

      The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding `endElement` event for every startElement event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement event.

      This event allows up to three name components for each element:

      1. the Namespace URI;
      2. the local name; and
      3. the qualified (prefixed) name.

      Any or all of these may be provided, depending on the values of the http://xml.org/sax/features/namespaces and the http://xml.org/sax/features/namespace-prefixes properties:

      - the Namespace URI and local name are required when the namespaces property is true (the default), and are optional when the namespaces property is false (if one is specified, both must be);
      - the qualified name is required when the namespace-prefixes property is true, and is optional when the namespace-prefixes property is false (the default).

      Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted. The attribute list will contain attributes used for Namespace declarations (xmlns* attributes) only if the `http://xml.org/sax/features/namespace-prefixes` property is true (it is false by default, and support for a true value is optional).

      Like `characters()`, attribute values may have characters that need more than one `char` value.

      Specified by:
        `startElement` in interface `ContentHandler`
      Parameters:
        `namespace` - the Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed
        `localName` - the local name (without prefix), or the empty string if Namespace processing is not being performed
        `qName` - the qualified name (with prefix), or the empty string if qualified names are not available
        `attrs` - the attributes attached to the element. If there are no attributes, it shall be an empty Attributes object. The value of this object after startElement returns is undefined
      See Also:
        `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`, `Attributes`, `AttributesImpl`

    - #### endElement

          public void endElement(java.lang.String namespace,
                        java.lang.String localName,
                        java.lang.String qName)

      Description copied from interface: `ContentHandler`
      Receive notification of the end of an element.

      The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding `startElement` event for every endElement event (even when the element is empty).

      For information on the names, see startElement.

      Specified by:
        `endElement` in interface `ContentHandler`
      Parameters:
        `namespace` - the Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed
        `localName` - the local name (without prefix), or the empty string if Namespace processing is not being performed
        `qName` - the qualified XML name (with prefix), or the empty string if qualified names are not available

    - #### startPrefixMapping

          public void startPrefixMapping(java.lang.String prefix,
                                java.lang.String uri)

      Description copied from interface: `ContentHandler`
      Begin the scope of a prefix-URI Namespace mapping.

      The information from this event is not necessary for normal Namespace processing: the SAX XML reader will automatically replace prefixes for element and attribute names when the `http://xml.org/sax/features/namespaces` feature is true (the default).

      There are cases, however, when applications need to use prefixes in character data or in attribute values, where they cannot safely be expanded automatically; the start/endPrefixMapping event supplies the information to the application to expand prefixes in those contexts itself, if necessary.

      Note that start/endPrefixMapping events are not guaranteed to be properly nested relative to each other: all startPrefixMapping events will occur immediately before the corresponding `startElement` event, and all `endPrefixMapping` events will occur immediately after the corresponding `endElement` event, but their order is not otherwise guaranteed.

      There should never be start/endPrefixMapping events for the "xml" prefix, since it is predeclared and immutable.

      Specified by:
        `startPrefixMapping` in interface `ContentHandler`
      Parameters:
        `prefix` - the Namespace prefix being declared. An empty string is used for the default element namespace, which has no prefix.
        `uri` - the Namespace URI the prefix is mapped to
      See Also:
        `ContentHandler.endPrefixMapping(java.lang.String)`, `ContentHandler.startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`

    - #### endPrefixMapping

          public void endPrefixMapping(java.lang.String prefix)

      Description copied from interface: `ContentHandler`
      End the scope of a prefix-URI mapping.

      See `startPrefixMapping` for details. These events will always occur immediately after the corresponding `endElement` event, but the order of `endPrefixMapping` events is not otherwise guaranteed.

      Specified by:
        `endPrefixMapping` in interface `ContentHandler`
      Parameters:
        `prefix` - the prefix that was being mapped. This is the empty string when a default mapping scope ends.
      See Also:
        `ContentHandler.startPrefixMapping(java.lang.String, java.lang.String)`, `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`

    - #### ignorableWhitespace

          public void ignorableWhitespace(char[] ch,
                                 int start,
                                 int length)

      This class is only used internally so this method should never be called.
      Specified by:
        `ignorableWhitespace` in interface `ContentHandler`
      Parameters:
        `ch` - the characters from the XML document
        `start` - the start position in the array
        `length` - the number of characters to read from the array
      See Also:
        `ContentHandler.characters(char[], int, int)`

    - #### processingInstruction

          public void processingInstruction(java.lang.String target,
                                   java.lang.String data)

      adds processing instruction node to DOM.
      Specified by:
        `processingInstruction` in interface `ContentHandler`
      Parameters:
        `target` - the processing instruction target
        `data` - the processing instruction data, or null if none was supplied. The data does not include any whitespace separating it from the target

    - #### setDocumentLocator

          public void setDocumentLocator(Locator locator)

      This class is only used internally so this method should never be called.
      Specified by:
        `setDocumentLocator` in interface `ContentHandler`
      Parameters:
        `locator` - an object that can return the location of any SAX document event
      See Also:
        `Locator`

    - #### skippedEntity

          public void skippedEntity(java.lang.String name)

      This class is only used internally so this method should never be called.
      Specified by:
        `skippedEntity` in interface `ContentHandler`
      Parameters:
        `name` - the name of the skipped entity. If it is a parameter entity, the name will begin with '%', and if it is the external DTD subset, it will be the string "[dtd]"

    - #### comment

          public void comment(char[] ch,
                     int start,
                     int length)

      Lexical Handler method to create comment node in DOM tree.
      Specified by:
        `comment` in interface `LexicalHandler`
      Parameters:
        `ch` - An array holding the characters in the comment.
        `start` - The starting position in the array.
        `length` - The number of characters to use from the array.

    - #### startCDATA

          public void startCDATA()

      Description copied from interface: `LexicalHandler`
      Report the start of a CDATA section.

      The contents of the CDATA section will be reported through the regular `characters` event; this event is intended only to report the boundary.

      Specified by:
        `startCDATA` in interface `LexicalHandler`
      See Also:
        `LexicalHandler.endCDATA()`

    - #### endCDATA

          public void endCDATA()

      Description copied from interface: `LexicalHandler`
      Report the end of a CDATA section.
      Specified by:
        `endCDATA` in interface `LexicalHandler`
      See Also:
        `LexicalHandler.startCDATA()`

    - #### startEntity

          public void startEntity(java.lang.String name)

      Description copied from interface: `LexicalHandler`
      Report the beginning of some internal and external XML entities.

      The reporting of parameter entities (including the external DTD subset) is optional, and SAX2 drivers that report LexicalHandler events may not implement it; you can use the `http://xml.org/sax/features/lexical-handler/parameter-entities` feature to query or control the reporting of parameter entities.

      General entities are reported with their regular names, parameter entities have '%' prepended to their names, and the external DTD subset has the pseudo-entity name "[dtd]".

      When a SAX2 driver is providing these events, all other events must be properly nested within start/end entity events. There is no additional requirement that events from `DeclHandler` or `DTDHandler` be properly ordered.

      Note that skipped entities will be reported through the `skippedEntity` event, which is part of the ContentHandler interface.

      Because of the streaming event model that SAX uses, some entity boundaries cannot be reported under any circumstances:

      - general entities within attribute values
      - parameter entities within declarations

      These will be silently expanded, with no indication of where the original entity boundaries were.

      Note also that the boundaries of character references (which are not really entities anyway) are not reported.

      All start/endEntity events must be properly nested.

      Specified by:
        `startEntity` in interface `LexicalHandler`
      Parameters:
        `name` - The name of the entity. If it is a parameter entity, the name will begin with '%', and if it is the external DTD subset, it will be "[dtd]".
      See Also:
        `LexicalHandler.endEntity(java.lang.String)`, `DeclHandler.internalEntityDecl(java.lang.String, java.lang.String)`, `DeclHandler.externalEntityDecl(java.lang.String, java.lang.String, java.lang.String)`

    - #### endDTD

          public void endDTD()

      Description copied from interface: `LexicalHandler`
      Report the end of DTD declarations.

      This method is intended to report the end of the DOCTYPE declaration; if the document has no DOCTYPE declaration, this method will not be invoked.

      Specified by:
        `endDTD` in interface `LexicalHandler`
      See Also:
        `LexicalHandler.startDTD(java.lang.String, java.lang.String, java.lang.String)`

    - #### endEntity

          public void endEntity(java.lang.String name)

      Description copied from interface: `LexicalHandler`
      Report the end of an entity.
      Specified by:
        `endEntity` in interface `LexicalHandler`
      Parameters:
        `name` - The name of the entity that is ending.
      See Also:
        `LexicalHandler.startEntity(java.lang.String)`

    - #### startDTD

          public void startDTD(java.lang.String name,
                      java.lang.String publicId,
                      java.lang.String systemId)
                        throws SAXException

      Description copied from interface: `LexicalHandler`
      Report the start of DTD declarations, if any.

      This method is intended to report the beginning of the DOCTYPE declaration; if the document has no DOCTYPE declaration, this method will not be invoked.

      All declarations reported through `DTDHandler` or `DeclHandler` events must appear between the startDTD and `endDTD` events. Declarations are assumed to belong to the internal DTD subset unless they appear between `startEntity` and `endEntity` events. Comments and processing instructions from the DTD should also be reported between the startDTD and endDTD events, in their original order of (logical) occurrence; they are not required to appear in their correct locations relative to DTDHandler or DeclHandler events, however.

      Note that the start/endDTD events will appear within the start/endDocument events from ContentHandler and before the first `startElement` event.

      Specified by:
        `startDTD` in interface `LexicalHandler`
      Parameters:
        `name` - The document type name.
        `publicId` - The declared public identifier for the external DTD subset, or null if none was declared.
        `systemId` - The declared system identifier for the external DTD subset, or null if none was declared. (Note that this is not resolved against the document base URI.)
      Throws:
        `SAXException` - The application may raise an exception.
      See Also:
        `LexicalHandler.endDTD()`, `LexicalHandler.startEntity(java.lang.String)`

Copyright © 2014 Apache XML Project. All Rights Reserved.